# debug info seem not works with D compiler
%global debug_package %{nil}

%global major_version 0
%global minor_version 9
%global patch_version 0
#%%global pre beta

Name:           libdparse
Version:        %{major_version}.%{minor_version}.%{patch_version}
Release:        1%{?pre:.%{pre}}%{?dist}
Summary:        Library for lexing and parsing D source code
Summary(fr):    Bibliothèque pour l'analyse syntaxique et grammaticale de code source D
License:        Boost
URL:            https://github.com/dlang-community/dsymbol

# curl -Lolibdparse-%%{version}%%{?pre:-%%{pre}}.tar.gz https://github.com/dlang-community/libdparse/archive/v%%{version}%%{?pre:-%%{pre}}.tar.gz
Source0:        %{name}-%{version}%{?pre:-%{pre}}.tar.gz
ExclusiveArch:  %{ldc_arches}

BuildRequires:  ldc stdx-allocator-devel
Requires:       ldc-phobos ldc-druntime stdx-allocator

%description
Library for lexing and parsing D source code.

%description -l fr
Bibliothèque pour l'analyse syntaxique et gramaticale de code source en D.

%package        devel
Summary:        Development files for %{name}
Summary(fr):    Fichiers de développement pour %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:    stdx-allocator-devel

%description devel
libdparse package contains header files for developing D applications
that use libdparse.

%description devel -l fr
Le paquet libdparse contient les fichiers d'entêtes pour développer
des applications en D utilisant libdparse.


%package geany-tags
Summary:        Support for enable autocompletion in geany
Summary(fr):    Support pour activer l'auto-complétion dans geany
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch
BuildRequires:  geany
Requires:       geany

%description geany-tags
Enable autocompletion for dsymbol library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque dsymbol dans geany (IDE)

%prep
%setup -q -n %{name}-%{version}%{?pre:-%{pre}}
# temp geany config directory for allow geany to generate tags
mkdir geany_config

echo "# Package Information for pkg-config
# Created: $(date)
# Licence: Boost
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_d_includedir}/
Name: %{name}
Description: Library for lexing and parsing D source code.
Version: %{version}
Libs: -L-ldparse
Cflags: -I %{_d_includedir}/%{name} ${DFLAGS}" > %{name}.pc


%build
DFLAGS='-w -release -g -O2'
src_dir='src'
sources=$(find "${src_dir}" -name '*.d')
LIBS='-L-ldl -L-ldruntime-ldc-shared  -L-lphobos2-ldc-shared -L-lstdx-allocator'
mkdir build
for f in ${sources[@]}; do
    d_path=$(dirname ${f});
    d_file=$(basename ${f});
    header_file=include/${d_path/${src_dir}}/${d_file/.d/.di}
    doc_file=doc-src/${d_path/${src_dir}}/${d_file/.d/.html}
    object_file=build/${d_path/${src_dir}}/${d_file/.d/.o}
    # generate header
    ldc2 -I "${src_dir}" -o- -c $f -Hf ${header_file};
    # generate doc
    ldc2 -I "${src_dir}" -o- -c $f -Df ${doc_file} doc-src/index.ddoc doc-src/macros.ddoc;
    # generate object
    ldc2 -I "${src_dir}" ${DFLAGS} -c -relocation-model=pic $f -of ${object_file}
done
# generate library
objects=$(find build -name '*.o')
ldc2 ${LIBS} -shared -soname %{name}.so.%{major_version} -of./lib/%{name}.so.%{version} ${objects}

# generate geany tags
headers=$(find src -name '*.d')
geany -c geany_config -g %{name}.d.tags ${headers[@]} 

%install
mkdir -p %{buildroot}/{%{_libdir},%{_d_includedir}/%{name},%{_datadir}/geany/tags/}

# header files
# FIXME: https://github.com/ldc-developers/ldc/issues/2797
#cp -r include/{std,dparse} %{buildroot}/%{_d_includedir}/
cp -r src/{std,dparse} %{buildroot}/%{_d_includedir}/

# shared library
install -m0755 lib/libdparse.so.%{version} %{buildroot}/%{_libdir}
pushd %{buildroot}/%{_libdir}
    ln -s libdparse.so.%{version} libdparse.so.%{major_version}
    ln -s libdparse.so.%{major_version} libdparse.so
popd

# doc
install -d %{buildroot}/%{_datadir}/doc/%{name}/html/
cp -r doc-src/{std,dparse} %{buildroot}/%{_datadir}/doc/%{name}/html

# geany tags
install -m0644 %{name}.d.tags %{buildroot}/%{_datadir}/geany/tags/

# pkgconfig
install -d %{buildroot}/%{_datadir}/pkgconfig
install -m 0644 %{name}.pc %{buildroot}/%{_datadir}/pkgconfig

%files
%license LICENSE_1_0.txt
%doc README.md
%{_libdir}/libdparse.so.%{version}
%{_libdir}/libdparse.so.%{major_version}

%files devel
%{_datadir}/pkgconfig/%{name}.pc
%{_includedir}/d/dparse
%{_includedir}/d/std/experimental/lexer.d
%{_libdir}/libdparse.so
%{_datadir}/doc/%{name}/html
%files geany-tags
%{_datadir}/geany/tags/%{name}.d.tags


%changelog
* Thu Aug  2 2018 MERCIER Jonathan <bioinfornatics at gmail.com> - 0.9.0-1
- Initial release
